#include <stdio.h>
#include <math.h>
#include <stdlib.h>

// Creates a text file containing compare match values for Timer 1

FILE *list;

void main()
{
float frequency, duty_cycle;
int i, start_value, x, off_value[88], on_value[88];
int clock = 8000000;
int prescaler[6] = {1, 8, 64, 256, 1024, 0};

printf("Program for determining compare match values for Timer 1, so piano notes can be replicated. Frequency of each key from 1 to 88 is calculated. Based on Timer 1 settings, corresponding start values are mathed out. Timer 1 is assumed to be 16 bits. Prescaler assumed to be either 1, 8, 64, 256 or 1024.\n\n");

printf("Enter AVR Crystal frequency in Hertz:\n");
scanf("%d",&clock);
printf("\nEnter prescaler value (1, 8, 64, 256 or 1024):\n");
scanf("%d",&x);
printf("\nEnter desired duty cycle in percent:\n");
scanf("%f",&duty_cycle);
printf("\n\n");

// Get index of prescaler
i = 0;
while (prescaler[i] != x){
	i++;
	if (i > 5){
		break;
	}
}
x = i;

// create a text file for writing
if ((list = fopen("list.txt", "w"))==NULL)
{
    printf("Cannot create file.\n");
}

fprintf(list, "Generated ON and OFF time values for 16-bit Timer 1. Program created by Eirik Taylor 2009.\n\nAVR Crystal Frequency: %d Hz\nPrescaler: 1:%d\nDuty Cycle: %.1f%%\n\n\n", clock, prescaler[x], duty_cycle);

duty_cycle = duty_cycle / 100;

for (i = 1; i <= 88; i++)
{
// Find frequency of current note in Hertz
	frequency = 440 * pow(pow(2.0,(1/12.0)),(i-49));
	//fprintf(list, "Key #%d has frequency: %f Hz\n", i, frequency);
	//printf("Key %d has frequency %f Hz.\n", i, frequency);

// Find period of frequency measured in timer 1 increments
	frequency = (clock / (prescaler[x] * frequency));
	
// Math out values with chosen duty cycle
	off_value[i-1] = frequency;
	
	frequency = (frequency * duty_cycle);
	
	// Set values in array
	on_value[i-1] = frequency;
	off_value[i-1] = off_value[i-1] - on_value[i-1];
}

// Print out Off-time values
fprintf(list, "OFF Values:\n\n");
for (i = 0; i <= 87; i++)
{
	if (off_value[i] > 65534)
	{
		fprintf(list, "Overflow, ");
	}else{	
		fprintf(list, "%d, ", off_value[i]);
	}
}

// Print out On-time values
fprintf(list, "\n\nON Values:\n\n");
for (i = 0; i <= 87; i++)
{
	if (on_value[i] > 65534)
	{
		fprintf(list, "Overflow, ");
	}else{	
		fprintf(list, "%d, ", on_value[i]);
	}
}

fprintf(list, "\n\nPut these numbers in the compare_off and compare_on arrays.");

// close file
fclose(list);

printf("No Errors? Check the new list.txt file in this program's directory. :-)\n");

}